/* /////////////////////////////////////////////////////////////////////////////
 * File:        stlsoft_cc_obsolete.h
 *
 * Purpose:     Contains definitions of the STLSoft libraries' symbols prior to
 *              version 1.5.1.
 *
 * Created:     24th December 2002
 * Updated:     11th September 2004
 *
 * Home:        http://stlsoft.org/
 *
 * Copyright (c) 2002-2004, Matthew Wilson and Synesis Software
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * - Neither the name(s) of Matthew Wilson and Synesis Software nor the names of
 *   any contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef STLSOFT_INCL_H_STLSOFT
# error stlsoft_cc_obsolete.h can only be included from within stlsoft.h, and should not be included directly
#endif /* !STLSOFT_INCL_H_STLSOFT */

/* File version */
# define STLSOFT_VER_H_STLSOFT_CC_OBSOLETE_MAJOR     2
# define STLSOFT_VER_H_STLSOFT_CC_OBSOLETE_MINOR     0
# define STLSOFT_VER_H_STLSOFT_CC_OBSOLETE_REVISION  1
# define STLSOFT_VER_H_STLSOFT_CC_OBSOLETE_EDIT      10

/* /////////////////////////////////////////////////////////////////////////////
 * Auto-generation and compatibility
 */

/*
[<[STLSOFT-AUTO:NO-DOCFILELABEL]>]
[<[STLSOFT-AUTO:NO-UNITTEST]>]
*/

/* /////////////////////////////////////////////////////////////////////////////
 * Symbol definitions
 */

#ifdef _STLSOFT_COMPILER_IS_UNKNOWN
# undef _STLSOFT_COMPILER_IS_UNKNOWN
#endif /* _STLSOFT_COMPILER_IS_UNKNOWN */

#ifdef __STLSOFT_COMPILER_IS_UNKNOWN
# define _STLSOFT_COMPILER_IS_UNKNOWN
#endif /* __STLSOFT_COMPILER_IS_UNKNOWN */


#ifdef _STLSOFT_COMPILER_IS_UNKNOWN
# undef _STLSOFT_COMPILER_IS_UNKNOWN
#endif /* _STLSOFT_COMPILER_IS_UNKNOWN */

#ifdef __STLSOFT_COMPILER_IS_UNKNOWN
# define _STLSOFT_COMPILER_IS_UNKNOWN
#endif /* __STLSOFT_COMPILER_IS_UNKNOWN */


#ifdef _STLSOFT_COMPILER_IS_BORLAND
# undef _STLSOFT_COMPILER_IS_BORLAND
#endif /* _STLSOFT_COMPILER_IS_BORLAND */

#ifdef __STLSOFT_COMPILER_IS_BORLAND
# define _STLSOFT_COMPILER_IS_BORLAND
#endif /* __STLSOFT_COMPILER_IS_BORLAND */


#ifdef _STLSOFT_COMPILER_IS_DMC
# undef _STLSOFT_COMPILER_IS_DMC
#endif /* _STLSOFT_COMPILER_IS_DMC */

#ifdef __STLSOFT_COMPILER_IS_DMC
# define _STLSOFT_COMPILER_IS_DMC
#endif /* __STLSOFT_COMPILER_IS_DMC */


#ifdef _STLSOFT_COMPILER_IS_GCC
# undef _STLSOFT_COMPILER_IS_GCC
#endif /* _STLSOFT_COMPILER_IS_GCC */

#ifdef __STLSOFT_COMPILER_IS_GCC
# define _STLSOFT_COMPILER_IS_GCC
#endif /* __STLSOFT_COMPILER_IS_GCC */


#ifdef _STLSOFT_COMPILER_IS_INTEL
# undef _STLSOFT_COMPILER_IS_INTEL
#endif /* _STLSOFT_COMPILER_IS_INTEL */

#ifdef __STLSOFT_COMPILER_IS_INTEL
# define _STLSOFT_COMPILER_IS_INTEL
#endif /* __STLSOFT_COMPILER_IS_INTEL */


#ifdef _STLSOFT_COMPILER_IS_MSVC
# undef _STLSOFT_COMPILER_IS_MSVC
#endif /* _STLSOFT_COMPILER_IS_MSVC */

#ifdef __STLSOFT_COMPILER_IS_MSVC
# define _STLSOFT_COMPILER_IS_MSVC
#endif /* __STLSOFT_COMPILER_IS_MSVC */


#ifdef _STLSOFT_COMPILER_IS_MWERKS
# undef _STLSOFT_COMPILER_IS_MWERKS
#endif /* _STLSOFT_COMPILER_IS_MWERKS */

#ifdef __STLSOFT_COMPILER_IS_MWERKS
# define _STLSOFT_COMPILER_IS_MWERKS
#endif /* __STLSOFT_COMPILER_IS_MWERKS */


#ifdef _STLSOFT_COMPILER_IS_WATCOM
# undef _STLSOFT_COMPILER_IS_WATCOM
#endif /* _STLSOFT_COMPILER_IS_WATCOM */

#ifdef __STLSOFT_COMPILER_IS_WATCOM
# define _STLSOFT_COMPILER_IS_WATCOM
#endif /* __STLSOFT_COMPILER_IS_WATCOM */


#ifdef _STLSOFT_CF_TEMPLATE_SUPPORT
# undef _STLSOFT_CF_TEMPLATE_SUPPORT
#endif /* _STLSOFT_CF_TEMPLATE_SUPPORT */

#ifdef __STLSOFT_CF_TEMPLATE_SUPPORT
# define _STLSOFT_CF_TEMPLATE_SUPPORT
#endif /* __STLSOFT_CF_TEMPLATE_SUPPORT */


#ifdef _STLSOFT_CF_EXCEPTION_SIGNATURE_SUPPORT
# undef _STLSOFT_CF_EXCEPTION_SIGNATURE_SUPPORT
#endif /* _STLSOFT_CF_EXCEPTION_SIGNATURE_SUPPORT */

#ifdef __STLSOFT_CF_EXCEPTION_SIGNATURE_SUPPORT
# define _STLSOFT_CF_EXCEPTION_SIGNATURE_SUPPORT
#endif /* __STLSOFT_CF_EXCEPTION_SIGNATURE_SUPPORT */


#ifdef _STLSOFT_CF_NATIVE_BOOL_SUPPORT
# undef _STLSOFT_CF_NATIVE_BOOL_SUPPORT
#endif /* _STLSOFT_CF_NATIVE_BOOL_SUPPORT */

#ifdef __STLSOFT_CF_NATIVE_BOOL_SUPPORT
# define _STLSOFT_CF_NATIVE_BOOL_SUPPORT
#endif /* __STLSOFT_CF_NATIVE_BOOL_SUPPORT */


#ifdef _STLSOFT_CF_NATIVE_WCHAR_T_SUPPORT
# undef _STLSOFT_CF_NATIVE_WCHAR_T_SUPPORT
#endif /* _STLSOFT_CF_NATIVE_WCHAR_T_SUPPORT */

#ifdef __STLSOFT_CF_NATIVE_WCHAR_T_SUPPORT
# define _STLSOFT_CF_NATIVE_WCHAR_T_SUPPORT
#endif /* __STLSOFT_CF_NATIVE_WCHAR_T_SUPPORT */


#ifdef _STLSOFT_CF_NATIVE_64BIT_INTEGER_SUPPORT
# undef _STLSOFT_CF_NATIVE_64BIT_INTEGER_SUPPORT
#endif /* _STLSOFT_CF_NATIVE_64BIT_INTEGER_SUPPORT */

#ifdef STLSOFT_CF_64BIT_INT_SUPPORT
# define _STLSOFT_CF_NATIVE_64BIT_INTEGER_SUPPORT
#endif /* STLSOFT_CF_64BIT_INT_SUPPORT */


#ifdef _STLSOFT_CF_NATIVE_LONG_LONG_SUPPORT
# undef _STLSOFT_CF_NATIVE_LONG_LONG_SUPPORT
#endif /* _STLSOFT_CF_NATIVE_LONG_LONG_SUPPORT */

#ifdef __STLSOFT_CF_NATIVE_LONG_LONG_SUPPORT
# define _STLSOFT_CF_NATIVE_LONG_LONG_SUPPORT
#endif /* __STLSOFT_CF_NATIVE_LONG_LONG_SUPPORT */


#ifdef _STLSOFT_CF_NATIVE___int64_SUPPORT
# undef _STLSOFT_CF_NATIVE___int64_SUPPORT
#endif /* _STLSOFT_CF_NATIVE___int64_SUPPORT */

#ifdef __STLSOFT_CF_NATIVE___int64_SUPPORT
# define _STLSOFT_CF_NATIVE___int64_SUPPORT
#endif /* __STLSOFT_CF_NATIVE___int64_SUPPORT */


#ifdef _STLSOFT_CF_FUNCTION_SIGNATURE_FULL_ARG_QUALIFICATION_REQUIRED
# undef _STLSOFT_CF_FUNCTION_SIGNATURE_FULL_ARG_QUALIFICATION_REQUIRED
#endif /* _STLSOFT_CF_FUNCTION_SIGNATURE_FULL_ARG_QUALIFICATION_REQUIRED */

#ifdef __STLSOFT_CF_FUNCTION_SIGNATURE_FULL_ARG_QUALIFICATION_REQUIRED
# define _STLSOFT_CF_FUNCTION_SIGNATURE_FULL_ARG_QUALIFICATION_REQUIRED
#endif /* __STLSOFT_CF_FUNCTION_SIGNATURE_FULL_ARG_QUALIFICATION_REQUIRED */


#ifdef _STLSOFT_CF_EXCEPTION_SUPPORT
# undef _STLSOFT_CF_EXCEPTION_SUPPORT
#endif /* _STLSOFT_CF_EXCEPTION_SUPPORT */

#ifdef __STLSOFT_CF_EXCEPTION_SUPPORT
# define _STLSOFT_CF_EXCEPTION_SUPPORT
#endif /* __STLSOFT_CF_EXCEPTION_SUPPORT */


#ifdef _STLSOFT_CF_NOTHROW_BAD_ALLOC
# undef _STLSOFT_CF_NOTHROW_BAD_ALLOC
#endif /* _STLSOFT_CF_NOTHROW_BAD_ALLOC */

#ifdef __STLSOFT_CF_NOTHROW_BAD_ALLOC
# define _STLSOFT_CF_NOTHROW_BAD_ALLOC
#endif /* __STLSOFT_CF_NOTHROW_BAD_ALLOC */


#ifdef _STLSOFT_CF_THROW_BAD_ALLOC
# undef _STLSOFT_CF_THROW_BAD_ALLOC
#endif /* _STLSOFT_CF_THROW_BAD_ALLOC */

#ifdef __STLSOFT_CF_THROW_BAD_ALLOC
# define _STLSOFT_CF_THROW_BAD_ALLOC
#endif /* __STLSOFT_CF_THROW_BAD_ALLOC */


#ifdef _STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_FUNDAMENTAL_ARGUMENT_SUPPORT
# undef _STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_FUNDAMENTAL_ARGUMENT_SUPPORT
#endif /* _STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_FUNDAMENTAL_ARGUMENT_SUPPORT */

#ifdef __STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_FUNDAMENTAL_ARGUMENT_SUPPORT
# define _STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_FUNDAMENTAL_ARGUMENT_SUPPORT
#endif /* __STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_FUNDAMENTAL_ARGUMENT_SUPPORT */


#ifdef _STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_CLASS_ARGUMENT_SUPPORT
# undef _STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_CLASS_ARGUMENT_SUPPORT
#endif /* _STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_CLASS_ARGUMENT_SUPPORT */

#ifdef __STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_CLASS_ARGUMENT_SUPPORT
# define _STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_CLASS_ARGUMENT_SUPPORT
#endif /* __STLSOFT_CF_TEMPLATE_CLASS_DEFAULT_CLASS_ARGUMENT_SUPPORT */


#ifdef _STLSOFT_CF_EXPLICIT_KEYWORD_SUPPORT
# undef _STLSOFT_CF_EXPLICIT_KEYWORD_SUPPORT
#endif /* _STLSOFT_CF_EXPLICIT_KEYWORD_SUPPORT */

#ifdef __STLSOFT_CF_EXPLICIT_KEYWORD_SUPPORT
# define _STLSOFT_CF_EXPLICIT_KEYWORD_SUPPORT
#endif /* __STLSOFT_CF_EXPLICIT_KEYWORD_SUPPORT */


#ifdef _STLSOFT_CF_MUTABLE_KEYWORD_SUPPORT
# undef _STLSOFT_CF_MUTABLE_KEYWORD_SUPPORT
#endif /* _STLSOFT_CF_MUTABLE_KEYWORD_SUPPORT */

#ifdef __STLSOFT_CF_MUTABLE_KEYWORD_SUPPORT
# define _STLSOFT_CF_MUTABLE_KEYWORD_SUPPORT
#endif /* __STLSOFT_CF_MUTABLE_KEYWORD_SUPPORT */


#ifdef _STLSOFT_CF_TYPENAME_PARAM_KEYWORD_SUPPORT
# undef _STLSOFT_CF_TYPENAME_PARAM_KEYWORD_SUPPORT
#endif /* _STLSOFT_CF_TYPENAME_PARAM_KEYWORD_SUPPORT */

#ifdef __STLSOFT_CF_TYPENAME_PARAM_KEYWORD_SUPPORT
# define _STLSOFT_CF_TYPENAME_PARAM_KEYWORD_SUPPORT
#endif /* __STLSOFT_CF_TYPENAME_PARAM_KEYWORD_SUPPORT */


#ifdef _STLSOFT_CF_TYPENAME_TYPE_KEYWORD_SUPPORT
# undef _STLSOFT_CF_TYPENAME_TYPE_KEYWORD_SUPPORT
#endif /* _STLSOFT_CF_TYPENAME_TYPE_KEYWORD_SUPPORT */

#ifdef __STLSOFT_CF_TYPENAME_TYPE_KEYWORD_SUPPORT
# define _STLSOFT_CF_TYPENAME_TYPE_KEYWORD_SUPPORT
#endif /* __STLSOFT_CF_TYPENAME_TYPE_KEYWORD_SUPPORT */


#ifdef _STLSOFT_CF_TYPENAME_TYPE_DEF_KEYWORD_SUPPORT
# undef _STLSOFT_CF_TYPENAME_TYPE_DEF_KEYWORD_SUPPORT
#endif /* _STLSOFT_CF_TYPENAME_TYPE_DEF_KEYWORD_SUPPORT */

#ifdef __STLSOFT_CF_TYPENAME_TYPE_DEF_KEYWORD_SUPPORT
# define _STLSOFT_CF_TYPENAME_TYPE_DEF_KEYWORD_SUPPORT
#endif /* __STLSOFT_CF_TYPENAME_TYPE_DEF_KEYWORD_SUPPORT */


#ifdef _STLSOFT_CF_MOVE_CONSTRUCTOR_SUPPORT
# undef _STLSOFT_CF_MOVE_CONSTRUCTOR_SUPPORT
#endif /* _STLSOFT_CF_MOVE_CONSTRUCTOR_SUPPORT */

#ifdef __STLSOFT_CF_MOVE_CONSTRUCTOR_SUPPORT
# define _STLSOFT_CF_MOVE_CONSTRUCTOR_SUPPORT
#endif /* __STLSOFT_CF_MOVE_CONSTRUCTOR_SUPPORT */


/* ////////////////////////////////////////////////////////////////////////// */
